## ide-search-engine ide-search-engine |

## Functions

#define | IDE_TYPE_SEARCH_ENGINE
GList * | ide_search_engine_get_providers ()
void | ide_search_engine_add_provider ()
IdeSearchContext * | ide_search_engine_search ()

## Signals

void | provider-added | Run Last

## Types and Values

| IdeSearchEngine

## Object Hierarchy

        GObject
        ╰── IdeObject
            ╰── IdeSearchEngine

## Description

## Functions

### IDE_TYPE_SEARCH_ENGINE

    #define IDE_TYPE_SEARCH_ENGINE (ide_search_engine_get_type())

### ide_search_engine_get_providers ()

    GList *
    ide_search_engine_get_providers (IdeSearchEngine *self);

Returns the list of registered search providers.

#### Returns

A GList of IdeSearchProvider.

[transfer none][element-type IdeSearchProvider*]

### ide_search_engine_add_provider ()

    void
    ide_search_engine_add_provider (IdeSearchEngine *self,
                                    IdeSearchProvider *provider);

### ide_search_engine_search ()

    IdeSearchContext *
    ide_search_engine_search (IdeSearchEngine *self,
                              const GList *providers,
                              const gchar *search_terms);

Begins a query against the requested search providers.

If `providers` is `NULL`, all registered providers will be used.

#### Parameters

providers | Optional list of specific providers to use when searching. | [allow-none][element-type IdeSearchProvider*]
search_terms | The search terms. |

#### Returns

An IdeSearchContext or `NULL` if no providers could be loaded.

[transfer full][nullable]

## Types and Values

### IdeSearchEngine

    typedef struct _IdeSearchEngine IdeSearchEngine;

## Signal Details

### The `“provider-added”` signal

    void
    user_function (IdeSearchEngine   *idesearchengine,
                   IdeSearchProvider *arg1,
                   gpointer           user_data)

Flags: Run Last